{# _datamax/api/templates/files/add_redshift.html_ #}
{% extends "validation_layout.html" %}

{% block body %}
<div class="row">
    <div class="col-md-8">
        <h5 class="card-title">Add Redshift table</h5>
    </div>
    <div class="col-md-4 text-right">

    </div>
</div>
<br/>
<form method="post" action="{{ url_for('api_exchange.index') }}" id="addRedshiftTableform">
    <input type="hidden" name="name" value="register_file_for_validation"/>
    <input type="hidden" name="source_type" value="rs"/>
    <input type="hidden" name="properties" id="properties"/>
    <input type="hidden" name="shape" id="shape" />
    <div class="form-group">
        <label for="project">Project</label>
        <select class="form-control" id="project" name="project">
            <option disabled selected value></option>
        </select>
        <small id="projectHelp" class="form-text text-muted">
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Connector</label>
        <select class="form-control" id="connector" name="connector_id">
            <option disabled selected value></option>
        </select>
        <small id="connectorHelp" class="form-text text-muted">
            Connections will be established at run time for the given resource key.
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Registration Name</label>
        <input type="text" class="form-control" id="file_name" placeholder="" name="file_name">
    </div>
    <div class="form-group">
        <label for="description">Description</label>
        <input type="text" class="form-control" id="description" placeholder="" name="description">
    </div>
    <div class="form-group">
        <label for="schema">Schema</label>
        <input type="text" class="form-control" id="schema" placeholder="" name="schema">
    </div>
    <div class="form-group">
        <label for="table_name">Table Name</label>
        <input type="text" class="form-control" id="table_name" placeholder="" name="table_name">
        <small id="objectHelp" class="form-text text-muted">
        </small>
    </div>
    <input type="submit" class="btn btn-primary float-right" name="submit" value="Add">
    <div class="loading float-right"></div>

</form>

<script>
    $("#addRedshiftTableform").submit(function() {
        // build properties
        $("#properties").val(JSON.stringify({
            "schema": $("input[name='schema']").val(),
            "table_name": $("input[name='table_name']").val(),
        }));

        var shapeFormData = "rs_connector_id="+ $("#connector").val() + "&schema=" + $("#schema").val() + "&table_name=" + $("#table_name").val();

        $.get("{{ url_for('operations.get_shape') }}?" + shapeFormData,  function (data) {
            console.log(data);
            $("#shape").val(JSON.stringify(data.shape));

            // submit the form
            $.ajax({
                 type: "GET",
                 url: $("#addRedshiftTableform").attr('action'),
                 data: $("#addRedshiftTableform").serialize(),
                 success: function(data) {
                    console.log(data);
                    window.location.href = "{{ url_for('views_validation.index') }}";
                 }
               }); // .second request ends
       });
       return false;
  });

   $(document).ready(function(){
        $.ajax({
            type:"POST",
            url: "{{ url_for('api_exchange.index') }}?name=all_projects",
            data: {},
            success: function(data) {
                console.log(data);
                $.each(data.Contents, function(index, val){
                    $("#project").append('<option value="' + val.id + '">' + val.name + '</option>');
                });
            }
        });

        $("#project").on( "change", function() {
            var project_id = $(this).val();
            $("#connector").html("<option disabled selected value></option>");
            $.ajax({
                type:"POST",
                url: "{{ url_for('api_exchange.index') }}?name=get_connections&connection_type=rs&project_id=" + project_id,
                data: {},
                success: function(data) {
                    console.log(data);
                    $.each(data.Contents, function(index, val){
                        $("#connector").append('<option value="' + val.id + '">' + val.name + '</option>');
                    });
                }
             });
        });
    });

</script>

{% endblock %}